﻿//css_ref CrystalDecisions.CrystalReports.Engine.dll;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Diagnostics;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.Providers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using Produmex.Sbo.Logex.Data.Devices;
using Produmex.Sbo.Logex.Data.DataObjects;
using static Produmex.Foundation.Data.Sbo.ViewObjects.Definitions.Views.PmxParameterValueViewDefinition.Columns;
using System.Collections.ObjectModel;
using Produmex.Foundation.Data.Sbo.DataObjects;
using System.Security.Cryptography;


namespace AddUpdateData
{
    internal class Program
    {
        private static string CONNECTION_STRING = "ADDYOURCONNECTIONSTRINGHERE";
        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);
        
        static void Main(string[] args)
        {
            try
            {
                DoSomething();
            }
            catch (Exception ex)                    
            {
                s_log.Error("", ex);
                Console.WriteLine(ex);
                Console.ReadLine();
            }
        }      

        public static void DoSomething()
        {
            List<int> Luids = new List<int>();
            List<int> PLDE = new List<int>();
			List<string> Pages = new List<string>();
            List<string> ItemCodes = new List<string>();
            int iLuids = 0;
            string PlDocEntries = "";
            string LastDocEntry = "";

			int lNum = 0;

            // OPEN TRANSACTION
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (PmxDbConnectionDirect conn = PmxDbConnectionMgr.GetDirectConnection(SboConnectionString.ParseStringToObject(CONNECTION_STRING)))
                {
                    conn.Open();
                    string query = @"select ItemCode, DocEntry, cast(U_LabelNum as int) as U_LabelNum from OWOR where U_LabelNum > 0 ";

                    using (ISboRecordset rs1 = SboRecordsetHelper.RunQuery(s_log, query, conn))
                    {
                        while (!rs1.EoF)
                        {
                            if (LastDocEntry != rs1.GetTypedValue<int>("DocEntry").ToString() )
                            {
                                if (PlDocEntries == "") { PlDocEntries = rs1.GetTypedValue<int>("DocEntry").ToString(); } 
                                    else { PlDocEntries += ", " + rs1.GetTypedValue<int>("DocEntry").ToString(); }
                                LastDocEntry = rs1.GetTypedValue<int>("DocEntry").ToString();
                            }
							lNum = rs1.GetTypedValue<int>("U_LabelNum");													
							for (int i = 0; i < lNum; i++) 
							{
								PmxLogisticUnitIDProvider luidProv = new PmxLogisticUnitIDProvider(conn);
								Luids.Add(luidProv.GenerateNewLogisticUnit(null));
								ItemCodes.Add(rs1.GetTypedValue<string>("itemCode"));
								PLDE.Add(rs1.GetTypedValue<int>("DocEntry"));
								Pages.Add( (i+1).ToString() + "/" + lNum.ToString() );
								iLuids++;
							}
                            rs1.MoveNext();
                        }
                    }
                }
                scope.Complete();
            }
            if (iLuids > 0) {
                using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
                {
                    using (PmxDbConnectionDirect conn = PmxDbConnectionMgr.GetDirectConnection(SboConnectionString.ParseStringToObject(CONNECTION_STRING)))
                    {
                        conn.Open();
                        PmxReportProvider reportProvider = new Produmex.Sbo.Logex.Data.Providers.PmxReportProvider(conn);
                        PmxReport report = reportProvider.GetBO(8);
                        PmxOsePrinterProvider printerProvider = new PmxOsePrinterProvider(conn);
                        PmxOsePrinter printer = printerProvider.GetBO("PRINTER");
                        for (int i = 0; i < iLuids; i++)
                        {
                            Collection<ReportParameter> reportParameters = new Collection<ReportParameter>();
                            reportParameters.Add(new ReportParameter("@luid", Luids[i]));
                            reportParameters.Add(new ReportParameter("@itemC", ItemCodes[i]));
                            reportParameters.Add(new ReportParameter("PLHE", PLDE[i]));
							reportParameters.Add(new ReportParameter("page", Pages[i]));
                            ReportPrinterDevice device = new ReportPrinterDevice(conn);
                            device.PrintReport(report, printer, null, 1, null, reportParameters);
                        }
                        string querySSCC = @"update OWOR set U_LabelNum = null where DocEntry in (" + PlDocEntries + ")";
                        //SboRecordsetHelper.RunQuery(s_log, querySSCC, conn);
                    }
                    scope.Complete();
                }
            }
        }
    }
}
